/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : AddFile.h
 * DATE   : 6.10.2006
 *******************************************************************/
#ifndef INCLUDED_AddFile_h
#define INCLUDED_AddFile_h

/*------- include files:
-------------------------------------------------------------------*/
#ifndef INCLUDED_QFileDialog
#define INCLUDED_QFileDialog
#include <QFileDialog>
#endif

/*------- forward declarations:
-------------------------------------------------------------------*/
class QGroupBox;
class QHBoxLayout;
class QCheckBox;

/*------- class declaration:
-------------------------------------------------------------------*/
class AddFile : public QFileDialog
{
	Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION *******
public:
	explicit AddFile( QWidget* in_parent, const QString& );
private:
	AddFile( const AddFile& );
	AddFile& operator=( const AddFile& );

// ******* CONSTANTS *******
private:
	static const char* const CAPTION;
	static const char* const GBOX_CAPTION;
	static const char* const SOURCE_FILE;
	static const char* const HEADER_FILE;
	static const char* const FILTER;

// ******* MEMBERS *******
private:
	QGroupBox*   const d_box;
	QHBoxLayout* const d_box_layout;
	QCheckBox*   const d_source;
	QCheckBox*   const d_header;
	QString            d_selected_file;
// ******* METHODS *******
public:
	bool           source_is_checked() const;
	bool           header_is_checked() const;
	const QString& selected_file    () const;
private slots:
	void current_changed( const QString& );
	void accept         ();
};

#endif // INCLUDED_AddFile_h
