/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : Bookmarks.h
 * DATE   : 12.02.2007
 *-------------------------------------------------------------------
 * OPIS   : SINGLETON
 *******************************************************************/

/*------- include files:
-------------------------------------------------------------------*/
#include "Bookmarks.h"
#include <QApplication>

//*******************************************************************
// Bookmarks                                     CONSTRUCTOR private
//*******************************************************************
Bookmarks::Bookmarks() : Points()
{
   setParent( qApp );
}
// end of Bookmarks

//*******************************************************************
// instance                                                   PUBLIC
//*******************************************************************
Bookmarks* Bookmarks::instance()
{
   static Bookmarks* ptr = 0;
   if( !ptr ) ptr = new Bookmarks();
   return ptr;
}
// end of instance

//*******************************************************************
// changed_status                                             PUBLIC
//*******************************************************************
void Bookmarks::change_status( const QString& in_fpath, const qint32 in_nr, const QString& in_text )
{
   if( in_nr != -1 ) {
      const PointStatus stat = status( in_fpath, in_nr );
      add( in_fpath, in_nr, ( stat != SET ) ? SET : UNSET, in_text );
   }
}
// end of changed_status
