/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : BrowserDbgData.h
 * DATE   : 06.02.2007
 *******************************************************************/
#ifndef INCLUDED_BrowserDbgData_h
#define INCLUDED_BrowserDbgData_h

/*------- include files:
-------------------------------------------------------------------*/
#include "DbgDataTable.h"


/*------- forward declarations:
-------------------------------------------------------------------*/
class Event;

/*------- class declaration:
-------------------------------------------------------------------*/
class BrowserDbgData : public DbgDataTable
{
	Q_OBJECT
public:
	BrowserDbgData( QWidget* = 0 );
	~BrowserDbgData();
private:
	BrowserDbgData( const BrowserDbgData& );
	BrowserDbgData& operator=( const BrowserDbgData& );

// ******* TYPES *******
private:
	enum {
		None = 0,
		Type,
		Value,
	};

// ******* CONSTANTS *******
private:
	static const qint32      NAME_COLUMN;
	static const qint32      VALUE_COLUMN;
	static const char* const NO_SYMBOL;

// ******* MEMBERS *******
private:
	qint32 d_status;

// ******* METHODS *******
private:
	void   customEvent ( QEvent* );
	void keyPressEvent ( QKeyEvent* );
	void    insert_row ();
	void    remove_row ();
	bool          edit ( const QModelIndex&, EditTrigger, QEvent* );
	void         error ();
	void     next_type ();
	void     item_type ( Event* );
	void    next_value ();
	void    item_value ( Event* );
	void     send_next ();
private slots:
	void  cell_changed ( int, int );
};

#endif // INCLUDED_BrowserDbgData_h
