/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : BrowserDbgScope.h
 * DATE   : 06.02.2007
 *******************************************************************/
#ifndef INCLUDED_BrowserDbgScope_h
#define INCLUDED_BrowserDbgScope_h

/*------- forward declarations:
-------------------------------------------------------------------*/
class Event;

/*------- include files:
-------------------------------------------------------------------*/
#include "DbgDataTable.h"


/*------- class declaration:
-------------------------------------------------------------------*/
class BrowserDbgScope : public DbgDataTable
{
	Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION *******
public:
	BrowserDbgScope( QWidget* = 0 );
	~BrowserDbgScope();
private:
	BrowserDbgScope( const BrowserDbgScope& );
	BrowserDbgScope& operator=( const BrowserDbgScope& );

// ******* TYPES *******
private:
	enum {
		None = 0,
		Type,
		Value,
	};
// ******* CONSTANTS *******
private:
	static const qint32  NAME_COLUMN;
	static const qint32  VALUE_COLUMN;
	static const QString UNKNOWN_MARK;

// ******* MEMBER *******
private:
	qint32  d_status;

// ******* METHODS *******
private:
	void customEvent ( QEvent* );
	void       scope ( Event* );
	void   item_type ( Event* );
	void  item_value ( Event* );
	void       error ();
	void    set_data ( qint32, const QString& );
	void   next_type ();
	void  next_value ();
};

#endif // INCLUDED_BrowserDbgScope_h
