/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : BrowserSearch.h
 * DATE   : 24.09.2006
 *******************************************************************/
#ifndef INCLUDED_BrowserMessages_h
#define INCLUDED_BrowserMessages_h

/*------- include files:
-------------------------------------------------------------------*/
#ifndef INCLUDED_QListWidget
#define INCLUDED_QListWidget
#include <QListWidget>
#endif // INCLUDED_QListWidget

/*------- forward declarations:
-------------------------------------------------------------------*/
class QEvent;
class QMouseEvent;
class Event;

/*------- class declaration:
-------------------------------------------------------------------*/
class BrowserMessages : public QListWidget
{
   Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION *******
public:
   explicit BrowserMessages( QWidget* = 0 );
   ~BrowserMessages();
private:
   BrowserMessages( const BrowserMessages& );
   BrowserMessages& operator=( const BrowserMessages& );

// ******* MEMBERS *******
private:
   QString  d_dir;
   QPalette d_org_palette;
   QFont    d_org_font;

// ******* METHODS *******
private:
   void  customEvent   ( QEvent* );
   void set_properties ();
   void add_item       ( Event* );
   void remove_marker  ( QString& ) const;
private slots:
   void      selection ( QListWidgetItem* );
};

#endif // INCLUDED_BrowserMessages_h
