/********************************************************************
 * Copyright (C) 2006-2008 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR  : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT : Cobras
 * FILE    : CBtBookmarks.h
 * DATE    : 12.02.2007
 * CHANGED : 02.07.2008
 *-------------------------------------------------------------------
 * OPIS   : SINGLETON
 *******************************************************************/

/*------- include files:
-------------------------------------------------------------------*/
#include "CBtBookmarks.h"

//*******************************************************************
// instance                                                   PUBLIC
//*******************************************************************
CBtBookmarks* const CBtBookmarks::instance()
{
   static CBtBookmarks* ptr = 0;
   return ( ptr ? ptr : ( ptr = new CBtBookmarks ) );
}
// end of instance

//*******************************************************************
// changed_status                                             PUBLIC
//*******************************************************************
void CBtBookmarks::change_status( const QString& in_fpath,
                                  const int      in_row  ,
                                  const QString& in_text  )
{
   if( -1 == in_row ) return;
   const TPointStatus stat = status( in_fpath, in_row );
   add( in_fpath, in_row, ( stat != SET ) ? SET : UNSET, in_text );
}
// end of changed_status
