/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : DbgCallStack.h
 * DATE   : 15.02.2007
 *******************************************************************/
#ifndef INCLUDED_DbgCallStack_h
#define INCLUDED_DbgCallStack_h

/*------- include files:
-------------------------------------------------------------------*/
#include "DbgToolDialog.h"
#include "DbgDataTable.h"

/*------- include files:
-------------------------------------------------------------------*/
class Event;

/*------- class declaration:
-------------------------------------------------------------------*/
class DbgCallStack : public DbgToolDialog
{
	Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION *******
public:
	DbgCallStack( QWidget* = 0 );
	~DbgCallStack();

// ******* LOCAL CONSTANTS *******
private:
	static const char* const CAPTION;
	static const QString     FRAME_BEGIN;
	static const QString     FRAME_END;
	static const QString     FUNCTION_NAME;
	static const QString     SOURCE_FILE;
	static const QString     SOURCE_LINE;
	static const QString     ERROR;

// ******* MEMBERS *******
private:
	DbgDataTable* const d_table;

// ******* METHODS *******
private:
	void   showEvent ( QShowEvent* );
	void  closeEvent ( QCloseEvent* );
	void customEvent ( QEvent* );
	void  parse_data ( const Event* );
	void   set_items ( const QStringList& );
};

#endif // INCLUDED_DbgCallStack_h
