/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : GetQmake.h
 * DATE   : 23.09.2006
 *******************************************************************/
#ifndef INCLUDED_GetQmake_h
#define INCLUDED_GetQmake_h

/*------- include files:
-------------------------------------------------------------------*/
#ifndef INCLUDED_QDialog
#define INCLUDED_QDialog
#include <QDialog>
#endif // INCLUDED_QDialog

/*------- forward declarations:
-------------------------------------------------------------------*/
class QLineEdit;

/*------- class declaration:
-------------------------------------------------------------------*/
class GetQmake : public QDialog
{
	Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION *******
public:
	explicit GetQmake( QWidget* );
private:
	GetQmake( const GetQmake& );
	GetQmake& operator=( const GetQmake& );

// ******* CONSTANTS *******
private:
	static const char* const CAPTION;
	static const char* const PROMPT;
	static const char* const GOTO;
	static const char* const CANCEL;
	static const char* const FILTER;

// ******* MEMBERS *******
private:
	QLineEdit* d_input;

// ******* METHODS *******
private slots:
	void accept();
	void select();
};

#endif // INCLUDED_GetQmake_h
