/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : Margin.h
 * DATE   : 11.11.2006
 *******************************************************************/
#ifndef INCLUDED_Margin_h
#define INCLUDED_Margin_h

/*------- include files:
-------------------------------------------------------------------*/
#include "Editor.h"
#include <QWidget>
#include <QPixmap>

/*------- class declaration:
-------------------------------------------------------------------*/
class Margin : public QWidget
{
   Q_OBJECT
public:
   Margin( QWidget* );
private:
   Margin( const Margin& );
   Margin& operator=( const Margin& );

// ******* CONSTANTS *******
private:
   static const char* const NEXT_BOOKMARK;
   static const char* const PREV_BOOKMARK;
   static const char* const TOGGLE_BOOKMARK;
   static const char* const LIST_BOOKMARK;

// ******* MEMBERS *******
private:
   qint32 width_;

// ******* METHODS *******
public:
   void   update_geometry      ();
   void   set_properties       ();
   qint32 width                ();
private:
   void  paintEvent            ( QPaintEvent* );
   void  mouseDoubleClickEvent ( QMouseEvent* );
   void  mousePressEvent       ( QMouseEvent* );
   void  context_menu          ( const QPoint& );
   bool  search_text_block     ( qint32, QTextBlock& ) const;
   bool  on_screen             ( qint32, qint32, qint32 ) const;
private slots:
   void  bookmark_next         ();
   void  bookmark_prev         ();
   void  bookmark_toggle       ();
   void  bookmark_all          ();
};

#endif // INCLUDED_Margin_h
