/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : ProjectQtMake.h
 * DATE   : 07.03.2007
 *******************************************************************/
#ifndef INCLUDED_ProjectQtMake_h
#define INCLUDED_ProjectQtMake_h

/*------- include files:
-------------------------------------------------------------------*/
#include "DataTable.h"
#include <QWidget>

/*------- forward declarations:
-------------------------------------------------------------------*/
class DataTable;

/*------- class declaration:
-------------------------------------------------------------------*/
class ProjectQtMake : public QWidget
{
	Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION *******
public:
	ProjectQtMake( QWidget* );
private:
	ProjectQtMake( const ProjectQtMake& );
	ProjectQtMake& operator=( const ProjectQtMake& );

// ******* CONSTANTS *******
private:
	static const char* const PROPOSITION;
	static const char* const CLEAR_ALL;
	static const QString     PROP_DBG;
	static const QString     PROP_REL;

// ******* MEMBERS *******
private:
	DataTable* const d_table;
private slots:
	void proposition ();
	void   clear_all ();
public:
	void set_qt_make ( const QHash< QString, QString >& );
	void get_qt_make ( QHash< QString, QString >& );
};

#endif // INCLUDED_ProjectQtMake_h
