/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : PropertiesClassTree.h
 * DATE   : 22.10.2006
 *******************************************************************/
#ifndef INCLUDED_PropertiesClassTree_h
#define INCLUDED_PropertiesClassTree_h

/*------- include files:
-------------------------------------------------------------------*/
#ifndef INCLUDED_PropertiesWidget_h
#include "PropertiesWidget.h"
#endif // INCLUDED_PropertiesWidget_h

/*------- class declaration:
-------------------------------------------------------------------*/
class PropertiesClassTree : public PropertiesWidget
{
	Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION ********
public:
	PropertiesClassTree( QWidget* );
private:
	PropertiesClassTree( const PropertiesClassTree& );
	PropertiesClassTree& operator=( const PropertiesClassTree& );

// ******* MEMBERS *******
private:
	bool d_showed;

// ******* METHODS *******
private:
	void showEvent ( QShowEvent* );
private slots:
	void save_data ();
};

#endif // INCLUDED_PropertiesClassTree_h
