/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : PropertiesGeneral.h
 * DATE   : 22.10.2006
 *******************************************************************/
#ifndef INCLUDED_PropertiesGeneral_h
#define INCLUDED_PropertiesGeneral_h

/*------- include files:
-------------------------------------------------------------------*/
#ifndef INCLUDED_QWidget
#define INCLUDED_QWidget
#include <QWidget>
#endif // INCLUDED_QWidget

/*------- forward declarations:
-------------------------------------------------------------------*/
class QVBoxLayout;
class QGroupBox;
class QGridLayout;
class QLabel;
class QCheckBox;
class QLineEdit;
class QPushButton;
class QButtonGroup;
class QRadioButton;

/*------- class declaration:
-------------------------------------------------------------------*/
class PropertiesGeneral : public QWidget
{
	Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION ********
public:
	PropertiesGeneral( QWidget* );
private:
	PropertiesGeneral( const PropertiesGeneral& );
	PropertiesGeneral& operator=( const PropertiesGeneral& );

// ******* CONSTANTS *******
private:
	static const char* const GBOX1_TITLE;
	static const char* const GBOX2_TITLE;
	static const char* const LOAD_PROJECT;
	static const char* const LOAD_FILES;
	static const char* const QMAKE_PATH;
	static const char* const CAPTION;
	static const char* const FILTER;
	static const char* const CLASS_PARSING_TITLE;
	static const char* const PARSE_ON_SAVE;
	static const char* const PARSE_ON_LINE;

// ******* MEMBERS *******
private:
	QVBoxLayout*  const d_main_layout;
	QGroupBox*    const d_gbox1;
	QGridLayout*  const d_glay1;
	QLabel*       const d_pload_lbl;
	QCheckBox*    const d_pload_cbx;
	QLabel*       const d_fload_lbl;
	QCheckBox*    const d_fload_cbx;
	QGroupBox*    const d_gbox2;
	QGridLayout*  const d_glay2;
	QLabel*       const d_qmake_lbl;
	QLineEdit*    const d_qmake_ted;
	QPushButton*  const d_qmake_btn;
	QGroupBox*    const d_gbox3;
	QVBoxLayout*  const d_glay3;
	QButtonGroup* const d_parse_bgrp;
	QRadioButton* const d_onsave_rbx;
	QRadioButton* const d_online_rbx;
	bool                d_showed;

// ******* METHODS *******
private:
	void showEvent( QShowEvent* );
private slots:
	void save_data();
	void get_path();
};

#endif // INCLUDED_PropertiesGeneral_h
