/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : PropertiesRMargin.h
 * DATE   : 12.05.2007
 *******************************************************************/
#ifndef INCLUDED_PropertiesRMargin_h
#define INCLUDED_PropertiesRMargin_h

/*------- include files:
-------------------------------------------------------------------*/
#include <QDialog>

/*------- forward declarations:
-------------------------------------------------------------------*/
class QGroupBox;
class QCheckBox;
class QPushButton;
class QLineEdit;
class QSpinBox;


/*------- class declaration:
-------------------------------------------------------------------*/
class PropertiesRMargin : public QDialog
{
	Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION *******
public:
	PropertiesRMargin( QWidget* );
	~PropertiesRMargin();
private:
	PropertiesRMargin( const PropertiesRMargin& );
	PropertiesRMargin& operator=( const PropertiesRMargin& );

// ******* CONSTANTS *******
private:
	static const char* const CAPTION;
	static const char* const USE_DEFAULTS;
	static const char* const SETTINGS;
	static const char* const DISPLAY;
	static const char* const SET_DEFAULTS;
	static const char* const ACCEPT;
	static const char* const EXIT;
	static const char* const LINE_COLOR;
	static const char* const LINE_POSITION;

// ******* MEMBERS *******
private:
	QGroupBox*   const gbox_;
	QCheckBox*   const use_defaults_cbx_;
	QSpinBox*    const n_spin_;
	QCheckBox*   const display_cbx_;
	QLineEdit*   const demo_line_color_;
	QPushButton* const line_color_btn_;
	QPushButton* const set_defaults_btn_;
	QPushButton* const accept_btn_;
	QPushButton* const exit_btn_;

// ******* METHODS *******
private:
	QRgb get_demo_color       ( const QLineEdit* );
	void set_demo_color       ( QLineEdit*, QRgb );
private slots:
	void accept_settings      ();
	void set_defaults_clicked ();
	void use_defaults_clicked ( bool );
	void line_color_clicked    ();
};

#endif // INCLUDED_PropertiesRMargin_h
