/********************************************************************
 * Copyright (C) 2006-2007 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : QBTFunctionsBox.h
 * DATE   : 14.06.2007
 *******************************************************************/
#ifndef INCLUDED_QBTFunctionsBox_h
#define INCLUDED_QBTFunctionsBox_h

/*------- include files:
-------------------------------------------------------------------*/
#include <QWidget>
#include <QDialog>
#include <QPointer>

/*------- forward declarations:
-------------------------------------------------------------------*/
class QListWidget;
class QListWidgetItem;
class QBTParserFunDef;

/*------- class declaration:
-------------------------------------------------------------------*/
class QBTFunctionsBox : public QDialog
{
   Q_OBJECT

// ******* TYPES *******
private:
   enum { POSITION = Qt::UserRole + 1 };

// ******* CONSTRUCTION / DESTRUCTION *******
public:
   QBTFunctionsBox( const QString&, QWidget* = 0 );
   ~QBTFunctionsBox();
private:
   QBTFunctionsBox( const QBTFunctionsBox& );
   QBTFunctionsBox& operator=( const QBTFunctionsBox& );

// ******* CONSTANTS *******
private:
   static const char* const CAPTION;
   
// ******* MEMBERS *******
private:
   const QPointer<QListWidget>     list_;
   const QPointer<QBTParserFunDef> parser_;
   qint32                          position_;
   
// ****** METHODS *******
private:
   void keyPressEvent   ( QKeyEvent* );
   void showEvent       ( QShowEvent* );
   void simplified      ( QString& );
private slots:
   void finished        ();
   void item_activated  ( QListWidgetItem* );
public:
   qint32 position() const { return position_; }
};

#endif // INCLUDED_QBTFunctionsBox_h
