/*******************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : QBTParserFunDef.cpp
 * DATE   : 13.06.2007
 //------------------------------------------------------------------
 // Obiekt-watek dokunujacy wyszukania w przyslanych tekscie
 // zrodlowym wszystkich definicji (!) funkcji.
 // Informacje o konkretnej funkcji sa zapisane w QBTCodeBlockInfo.
 // Wszystkie informacje sa przechowywane w vector<QBTCodeBlockInfo>.
 // Informacje mozna sobie odebrac za pomoca funkcji data().
 *******************************************************************/

/*------- include files:
-------------------------------------------------------------------*/
#include "QBTParserFunDef.h"
#include "QBtParser.h"
#include <QtDebug>
using namespace std;

//*******************************************************************
// run                                             PRIVATE inherited
//*******************************************************************
void QBTParserFunDef::run()
{
   data_.clear();

   if( !text_.isEmpty() ) {
      QBTCodeBlockInfo cbi;
      qint32 idx = 0;
      while( QBtParser::search_code_block( text_, idx, cbi ) ) {
//         cbi.print();
         data_.push_back( cbi );
         idx = cbi.is_valid() ? ( cbi.close_idx() + 1 )
                              : next_idx( cbi.pos_idx() );         
         if( -1 == idx ) break;
      }
   }
}
// end of run

//*******************************************************************
// parse_it                                                  PRIVATE
//*******************************************************************
void QBTParserFunDef::parse_it(  const QString&         in_text,
                                 const CodeBlockVector& in_muster )
{
   text_ = in_text;
   muster_ = in_muster;
   start();
}
// end of parse_it

//*******************************************************************
// next_idx                                                  PRIVATE
//*******************************************************************
qint32 QBTParserFunDef::next_idx( const qint32 in_idx ) const
{
   qint32 retval = -1;

   CodeBlockVector::const_iterator it = muster_.begin();
   const CodeBlockVector::const_iterator end = muster_.end();
   while( it != end ) {
      if( it->pos_idx() > in_idx ) {
         retval = it->pos_idx() - 1;
         break;
      }
      ++it;
   }
   return retval;
}
// end of next_idx

//*******************************************************************
// data                                                       PUBLIC
//*******************************************************************
void QBTParserFunDef::data( CodeBlockVector& out_data ) const
{
   out_data = data_;
}
// end of data;
