/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : QBtBottomkick.cpp
 * DATE   : 2007.10.14
 *******************************************************************/

/*------- include files:
-------------------------------------------------------------------*/
#include "QBtBottomkick.h"
#include "QBtMessageTab.h"
#include <QAction>

/*------- static constants:
-------------------------------------------------------------------*/
const char* const QBtBottomkick::CAPTION   = QT_TR_NOOP( "Message area" );
const QString     QBtBottomkick::ICON_NAME = ":/img/dock_v.png";
const QString     QBtBottomkick::NAME      = "bottomkick";

//*******************************************************************
// QBtBottomkick                                           CONSTRUCTOR
//*******************************************************************
QBtBottomkick::QBtBottomkick( QWidget* const in_parent ) : QDockWidget( in_parent )
, tab_ ( new QBtMessageTab )
{
   setObjectName( NAME );
   setFeatures( DockWidgetClosable );
   setAllowedAreas( Qt::BottomDockWidgetArea );
   toggleViewAction()->setIcon( QIcon( ICON_NAME ) );
   setWidget( tab_ );

   retranslate();
}
// end of QBtBottomkick

//*******************************************************************
// retranslate                                                PUBLIC
//*******************************************************************
void QBtBottomkick::retranslate()
{
   setWindowTitle( tr( CAPTION ) );
   tab_->retranslate();
}
// end of retranslate
