/********************************************************************
 * Copyright (C) Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : QBtSidekick.cpp
 * DATE   : 2007.10.14
 *******************************************************************/

/*------- include files:
-------------------------------------------------------------------*/
#include "QBtSidekick.h"
#include "QBtProjectTab.h"
#include <QAction>

/*------- constants:
-------------------------------------------------------------------*/
const char* const QBtSidekick::CAPTION   = QT_TR_NOOP( "Sidekick" );
const QString     QBtSidekick::ICON_NAME = ":/img/dock_h.png";
const QString     QBtSidekick::NAME      = "sidekick";

//*******************************************************************
// QBtSidekick                                           CONSTRUCTOR
//*******************************************************************
QBtSidekick::QBtSidekick( QWidget* const in_parent ) : QDockWidget( in_parent )
, tab_ ( new QBtProjectTab )
{
   setObjectName( NAME );
   toggleViewAction()->setIcon( QIcon( ICON_NAME ) );
   setAllowedAreas( Qt::LeftDockWidgetArea | Qt::RightDockWidgetArea );
   setWindowTitle( tr( CAPTION ) );
   setWidget( tab_ );
}
// end of QBtSidekick

//*******************************************************************
// retranslate                                                PUBLIC
//*******************************************************************
void QBtSidekick::retranslate()
{
   setWindowTitle( tr( CAPTION ) );
   tab_->retranslate();
}
// end of retranslate
