/********************************************************************
 * Copyright (C) 2006 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Cobras.
 *
 * Cobras is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cobras is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Cobras
 * FILE   : ToolsTable.h
 * DATE   : 21.05.2007
 *******************************************************************/
#ifndef INCLUDED_ToolsTable_h
#define INCLUDED_ToolsTable_h

/*------- include files:
-------------------------------------------------------------------*/
#include <QListWidget>

/*------- class declaration:
-------------------------------------------------------------------*/
class ToolsTable : public QListWidget
{
   Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION *******
public:
   ToolsTable( QWidget* = 0 );
private:
   ToolsTable( const ToolsTable& );
   ToolsTable& operator=( const ToolsTable& );

// ******* METHODS *******
private:
   QListWidgetItem* new_item() const;
public:
   bool                   get_data ( QStringList& ) const;
   void                   set_data ( const QStringList& );
private slots:
   void                   append   ();
   void                   insert   ();
   void                   remove   ();
   void                   up       ();
   void                   down     ();
};

#endif // INCLUDED_ToolsTable_h
